

#include "writer.h"
#include <unistd.h>



cPvr350Writer::cPvr350Writer(cRingBuffLinear *ring, int fd)
{
    output = fd;

    m_RingBuffer = ring;
    running = true;

    Start();
}



cPvr350Writer::~cPvr350Writer()
{
    running = false;
    Cancel();
}



void cPvr350Writer::Action()
{ 
    unsigned char *buf;
    int length;
    int max = 1000;
    printf("Writer started pid %d\n",getpid());
        while(running) {
        if ( (buf = m_RingBuffer->Get(length) ) != NULL ) {
	    if ( length >= max) {
		length = max;
                safe_write(output,buf,length);                           
                m_RingBuffer->Del(length);  
            } else {
	        cCondWait::SleepMs(1);
            }
        } else {
	    cCondWait::SleepMs(1);
        }
                         
    }       
}

